package com.fr.plugin.xx.saml.conf;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.stable.StringUtils;


/**
 * @author xx
 * @since 2021/12/04
 */
@Visualization(category = "saml门户配置")
public class SamlSsoConfig extends DefaultConfiguration {

    private static volatile SamlSsoConfig config = null;

    public static SamlSsoConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(SamlSsoConfig.class);
        }
        return config;
    }

    @Identifier(value = "debugSwitch", name = "插件调试开关", description = "日志调试模式", status = Status.SHOW)
    private Conf<Boolean> debugSwitch = Holders.simple(true);

    public Boolean getDebugSwitch() {
        return debugSwitch.get();
    }

    public void setDebugSwitch(Boolean debugSwitch) {
        this.debugSwitch.set(debugSwitch);
    }

    @Identifier(value = "key", name = "解密秘钥", description = "解密秘钥", status = Status.SHOW)
    private Conf<String> key = Holders.simple(StringUtils.EMPTY);

    public String getKey() {
        return key.get();
    }

    public void setKey(String k) {
        key.set(k);
    }

    @Identifier(value = "timeout", name = "超时时间", description = "超时时间", status = Status.SHOW)
    private Conf<Integer> timeout = Holders.simple(10);

    public Integer getTimeout() {
        return timeout.get();
    }

    public void setTimeout(Integer time) {
        timeout.set(time);
    }

    @Identifier(value = "samlUrl", name = "saml跳转地址", description = "saml跳转地址", status = Status.SHOW)
    private Conf<String> samlUrl = Holders.simple(StringUtils.EMPTY);

    public String getSamlUrl() {
        return samlUrl.get();
    }

    public void setSamlUrl(String key) {
        samlUrl.set(key);
    }

    @Identifier(value = "logout", name = "logout", description = "登出地址", status = Status.SHOW)
    private Conf<String> logout = Holders.simple(StringUtils.EMPTY);

    public String getLogout() {
        return logout.get();
    }

    public void setLogout(String key) {
        logout.set(key);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        SamlSsoConfig cloned = (SamlSsoConfig) super.clone();
        cloned.debugSwitch = (Conf<Boolean>) debugSwitch.clone();
        cloned.logout = (Conf<String>) logout.clone();
        cloned.timeout = (Conf<Integer>) timeout.clone();
        cloned.key = (Conf<String>) key.clone();
        cloned.samlUrl = (Conf<String>) samlUrl.clone();
        return cloned;
    }


    public boolean isAccept() {
        return StringUtils.isNotBlank(getKey()) && StringUtils.isNotBlank(getSamlUrl());
    }
}
